<p data-track="1"><span style="letter-spacing: 1.5px;"><strong><span style="color: #057C79; --tt-darkmode-color: #057C79;">对于应收账款，作为财务的你是否在关心：谁欠钱？谁欠的多？谁欠的久？</span></strong></span></p><p data-track="3"><span style="letter-spacing: 1.5px;"><span style="color: #121212; --tt-darkmode-color: #A3A3A3;">当应收账款未能按时收回时，就会</span>降低企业资金的使用效率，使企业效益下降。</span></p><p data-track="5"><span style="letter-spacing: 1.5px;">在<span class="candidate-entity-word" data-gid="8860558" qid="6595523477287998728" mention-index="0">赊销</span>业务中，企业发出商品并开票确认收入后，货款却不能同步到账，这种没有货款回笼的销售收入，势必会形成没有现金流入的<span class="candidate-entity-word" data-gid="445244" qid="6586606237725529351" mention-index="0">会计利润</span>，企业还需垫支由此产生的相关税款。</span></p><p data-track="7"><span style="letter-spacing: 1.5px;">对于应收账款的管理成本、清欠过程中的中介费用等都会增加企业的现金流出，这不仅占用了大量的流动资金，还将影响企业现金流的正常运转。</span></p><p data-track="9"><span style="letter-spacing: 1.5px;">在今天的案例中，<strong><span style="color: #057C79; --tt-darkmode-color: #057C79;">为规避应收账款变成坏账的风险，小秘书将与大家分享跟应收账款账龄分析相关的实用工具，</span></strong>教大家如何借助数字化技术<span class="candidate-entity-word" data-gid="5387537" qid="6595510066000958728" mention-index="0">Python</span>依据应收账款数据的“凭证日期”统计<span class="candidate-entity-word" data-gid="18759881" qid="6585841602273514766" mention-index="1">账龄</span>。</span></p><p data-track="11"><span style="letter-spacing: 1.5px;"><strong><span style="color: #057C79; --tt-darkmode-color: #057C79;">在案例中，我们将运用先进先出的原则：</span></strong></span></p><ul><li data-track="13"><span style="letter-spacing: 1.5px;">如果应收账款借方<span class="candidate-entity-word" data-gid="14582259" qid="6579650239857169678" mention-index="0">发生额</span>已经实现回款，那么，这部分交易不影响我们对应收账龄的统计；</span></li><li data-track="15"><span style="letter-spacing: 1.5px;">倒序统计应收账款余额分布在哪几笔借方发生里（定义为“实际应收”），即可按实际应收借方发生的日期统计应收账款账龄。</span></li></ul><p data-track="17"><span style="letter-spacing: 1.5px;">（在本次案例中，我们暂不考虑应收账款借方红字的情况）</span></p><p data-track="19"><span style="letter-spacing: 1.5px;"><strong><span style="color: #057C79; --tt-darkmode-color: #057C79;">一般来说，应收账款清账操作需要在核算系统中找到对应的应收账款借方凭证，然后对该笔凭证进行冲销。</span></strong>在这种情况下，统计应收账款账龄只需要找到未冲销的应收账款，计算凭证日期/交易日期至统计日期的间隔时长就可以了。</span></p><div class="business-container-rtb" data-content='{"selector":"business-container-rtb"}'></div><p data-track="21"><span style="letter-spacing: 1.5px;">我们使用先进先出的方法统计截止2020/9/30的应收账龄，账龄分段格式如下：</span></p><div class="pgc-img"><img src="https://www.idoola.cn/wp-content/uploads/2022/06/221785e7.jpg"/><p class="pgc-img-caption"></p></div><div class="business-container-rtb" data-content='{"selector":"business-container-brand"}'></div><p style="text-align: center;" data-track="24"><span style="font-size: 1.059em;"><strong><span style="color: #FFFFFF; --tt-darkmode-color: #FFFFFF;"><span style="background-color: #008585; --tt-darkmode-bgcolor: #008585;">1</span></span></strong></span></p><p style="text-align: center;" data-track="25"><span style="font-size: 1.059em;"><strong><span style="color: #FFFFFF; --tt-darkmode-color: #FFFFFF;"><span style="background-color: #057C79; --tt-darkmode-bgcolor: #057C79;">数据准备</span></span></strong></span></p><p data-track="27"><span style="letter-spacing: 1.5px;">引入应收账款凭证数据：</span></p><pre><code>import <span class="candidate-entity-word" data-gid="3808182" qid="6537175580364788995" mention-index="0">pandas</span> as pd
from datetime import datetime, date
import warnings
warnings.filterwarnings(&#34;ignore&#34;)
pd.options.display.float_format = &#39;{:,.2f}&#39;.format
file = &#39;财会实验数据.xlsx&#39;
df = pd.read_excel(file, sheet_name=&#39;客户往来账&#39;)
df.fillna(0,inplace=True)
df</code></pre><div class="pgc-img"><img src="https://www.idoola.cn/wp-content/uploads/2022/06/z1kQ2uFI.jpg"/><p class="pgc-img-caption"></p></div><p style="text-align: center;" data-track="40"><span style="font-size: 1.059em;"><strong><span style="color: #FFFFFF; --tt-darkmode-color: #FFFFFF;"><span style="background-color: #008585; --tt-darkmode-bgcolor: #008585;">2</span></span></strong></span></p><p style="text-align: center;" data-track="41"><span style="font-size: 1.059em;"><span style="letter-spacing: 1px;"><strong><span style="color: #FFFFFF; --tt-darkmode-color: #FFFFFF;"><span style="background-color: #057C79; --tt-darkmode-bgcolor: #057C79;">数据处理</span></span></strong></span></span></p><p data-track="43"><span style="letter-spacing: 1.5px;">根据实验要求，按每个客户先进先出的原则统计账龄。因此先对应收账款数据按客groupby，再在每个group中进行账龄计算，group内的账龄计算逻辑我们命名为AR函数。</span></p><pre><code>def AR(x):
# 计算客户<span class="candidate-entity-word" data-gid="2107486" qid="6579572653261067533" mention-index="0">应收款</span>余额
total = x[&#39;本币金额&#39;].sum()
# 统计应收账款借方
df_dr = x[x[&#39;本币金额&#39;]&gt;0]
# 按过账日期降序
df_dr = df_dr.sort_values(by=[&#39;过帐日期&#39;],ascending=False).reset_index(drop=True)
# 应收账款先进先出，因此将余额分摊在最后几笔借方交易，一旦分摊完则停止
for index, row in df_dr.iterrows():
if total-row[&#39;本币金额&#39;]&gt;0:
df_dr.loc[index,&#39;实际应收&#39;] = row[&#39;本币金额&#39;]
else:
df_dr.loc[index,&#39;实际应收&#39;] = total
break
total = total-row[&#39;本币金额&#39;]
return df_dr
df2 = df.groupby(&#39;客户编号&#39;,as_index=False).apply(AR)
# 找一个客户验证计算结果
df2.loc[df2[&#39;客户编号&#39;]==23500000]</code></pre><div class="pgc-img"><img src="https://www.idoola.cn/wp-content/uploads/2022/06/cW0du258.jpg"/><p class="pgc-img-caption"></p></div><p data-track="66"><span style="letter-spacing: 1.5px;"><strong>过滤实际应收为空或者为0的数据（代表已清账）</strong></span></p><pre><code>df3=df2[（pd.isna(df2[&#39;实际应收&#39;]）
==False）&（df2[&#39;实际应收&#39;]！=0）
df3.loc[df3[&#39;客户编号&#39;]==23500000]</code></pre><div class="pgc-img"><img src="https://www.idoola.cn/wp-content/uploads/2022/06/SFgFe4QZ.jpg"/><p class="pgc-img-caption"></p></div><p style="text-align: center;" data-track="75"><span style="font-size: 1.059em;"><strong><span style="color: #FFFFFF; --tt-darkmode-color: #FFFFFF;"><span style="background-color: #008585; --tt-darkmode-bgcolor: #008585;">3</span></span></strong></span></p><p style="text-align: center;" data-track="76"><span style="font-size: 1.059em;"><span style="letter-spacing: 1px;"><strong><span style="color: #FFFFFF; --tt-darkmode-color: #FFFFFF;"><span style="background-color: #057C79; --tt-darkmode-bgcolor: #057C79;">数据计算</span></span></strong></span></span></p><p data-track="78"><span style="letter-spacing: 1.5px;">计算每笔实际应收账款截止2020/9/30的账龄，账龄以月份数据表示，不足一月的按照天数/30计算小数。</span></p><pre><code>enddate = date(2020, 9, 30)
def totalmonth(startdate):
return round((enddate.year-startdate.year)*12 + (enddate.month-startdate.month) + (enddate.day-startdate.day)/30,2)
df3[&#39;账龄&#39;]=df3[&#39;过帐日期&#39;].map(totalmonth)
df3.loc[df3[&#39;客户编号&#39;]==23500000]</code></pre><div class="pgc-img"><img src="https://www.idoola.cn/wp-content/uploads/2022/06/9qJWfSJx.jpg"/><p class="pgc-img-caption"></p></div><p data-track="87"><span style="letter-spacing: 1.5px;"><strong><span style="color: #057C79; --tt-darkmode-color: #057C79;">计算账龄区间：使用条件判断</span></strong></span></p><p data-track="89"><span style="letter-spacing: 1.5px;">? 当账龄小于等于3个月时，落入账龄区间 1-3月；<br>? 当账龄大于3个月小于等于12个月时，落入账龄区间 3月-1年；<br>? 当账龄大于12个月小于等于24个月时，落入账龄区间 1-2年；<br>? 当账龄大于36个月时，落入账龄区间 3年以上。</span></p><pre><code>def age(totalmonth):
if totalmonth&lt;=3:
age=&#39;1-3月&#39;
elif totalmonth&lt;=12:
age=&#39;3月-1年&#39;
elif totalmonth&lt;=24:
age=&#39;1-2年&#39;
else:
age=&#39;3年以上&#39;
return age
df3[&#39;账龄区间&#39;]=df3[&#39;账龄&#39;].map(age)
df3.loc[df3[&#39;客户编号&#39;]==23500000]</code></pre><div class="pgc-img"><img src="https://www.idoola.cn/wp-content/uploads/2022/06/J8a5rI30.jpg"/><p class="pgc-img-caption"></p></div><p data-track="105"><span style="letter-spacing: 1.5px;"><strong><span style="color: #057C79; --tt-darkmode-color: #057C79;">账龄统计：</span></strong></span></p><pre><code>pd.pivot_table(df3,index[&#39;客户编号&#39;],
columns=[&#39;账龄区间&#39;],
values=[&#39;实际应收&#39;],aggfunc=
sum,fill_value=0）</code></pre><div class="pgc-img"><img src="https://www.idoola.cn/wp-content/uploads/2022/06/2SDyG9R6.jpg"/><p class="pgc-img-caption"></p></div><p data-track="113"><span style="letter-spacing: 1.5px;">以上就是用Python自动计算应收账款账龄的操作步骤了。公司的应收账款在流动资产中具有举足轻重的地位，如果公司的应收账款能及时收回，那么公司的资金使用效率将能大幅提高！</span></p><p style="text-align: left;" data-track="121"><span style="color: #888888; --tt-darkmode-color: #888888;">?图片版权归财码数字化所有，如对版权有异议，请联系后台议定处理。</span></p><p style="text-align: left;" data-track="122"><span style="color: #888888; --tt-darkmode-color: #888888;">本文由财码数字化整理发布，如需转载请务必注明以上信息。</span></p>